## ros-one-realtime-tools 1.15.1-3jammy.20251023.0330

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(realtime_tools)

# Load catkin and all dependencies required for this package
find_package(catkin REQUIRED COMPONENTS roscpp)
find_package(Threads REQUIRED)

include_directories(include)

# Declare catkin package
catkin_package(
  CATKIN_DEPENDS roscpp
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
  )

add_library(${PROJECT_NAME} src/realtime_clock.cpp)
target_link_libraries(${PROJECT_NAME} PUBLIC ${catkin_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
target_include_directories(${PROJECT_NAME} PUBLIC ${catkin_INCLUDE_DIRS})

# Unit Tests
if (CATKIN_ENABLE_TESTING)
  catkin_add_gmock(realtime_box_tests test/realtime_box_tests.cpp)
  target_link_libraries(realtime_box_tests ${PROJECT_NAME} ${GMOCK_MAIN_LIBRARIES})

  catkin_add_gmock(realtime_buffer_tests test/realtime_buffer_tests.cpp)
  target_link_libraries(realtime_buffer_tests ${PROJECT_NAME} ${GMOCK_MAIN_LIBRARIES})

  catkin_add_gmock(realtime_clock_tests test/realtime_clock_tests.cpp)
  target_link_libraries(realtime_clock_tests ${PROJECT_NAME})

  find_package(rostest REQUIRED)
  add_rostest_gmock(realtime_publisher_tests test/realtime_publisher.test test/realtime_publisher_tests.cpp)
  find_package(std_msgs REQUIRED)
  target_link_libraries(realtime_publisher_tests ${PROJECT_NAME} ${std_msgs_LIBRARIES})
  target_include_directories(realtime_publisher_tests PRIVATE ${std_msgs_INCLUDE_DIRS})

  add_rostest_gmock(realtime_server_goal_handle_tests test/realtime_server_goal_handle.test test/realtime_server_goal_handle_tests.cpp)
  find_package(actionlib REQUIRED)
  target_link_libraries(realtime_server_goal_handle_tests ${PROJECT_NAME} ${actionlib_LIBRARIES})
  target_include_directories(realtime_server_goal_handle_tests PRIVATE ${actionlib_INCLUDE_DIRS})
endif()

# Install
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})

=== debian/changelog ===
ros-one-realtime-tools (1.15.1-3jammy.20251023.0330) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 23 Oct 2025 03:30:11 +0000

ros-one-realtime-tools (1.15.1-0jammy) jammy; urgency=high

  * Check whether thread joinable before joining
  * realtime_server_goal_handle_tests needs actionlib
  * Contributors: Maverobot, Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 06 Feb 2020 00:00:00 -0000

ros-one-realtime-tools (1.15.0-0jammy) jammy; urgency=high

  * Remove actionlib definitions
  * Contributors: Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 09 Aug 2019 00:00:00 -0000

ros-one-realtime-tools (1.14.0-0jammy) jammy; urgency=high

  * Undo action typedef changes
  * Remove boost
  * Clean up includes in realtime_tools namespace
  * Switch to gmock
  * Remove TARGET check on tests
  * Add unit test for RealtimeServerGoalHandle, RealtimePublisher, RealtimeClock, RealtimeBuffer, RealtimeBox
  * Fix race where first message won't get published
  * Clean up dependencies and package.xml
  * Contributors: Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 22 Jul 2019 00:00:00 -0000

ros-one-realtime-tools (1.13.1-0jammy) jammy; urgency=high

  * Fix actionlib regression
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 14 Feb 2019 00:00:00 -0000

ros-one-realtime-tools (1.13.0-0jammy) jammy; urgency=high

  * Update readme
  * use this_thread::sleep_for instead of usleep (#32 <https://github.com/ros-controls/realtime_tools/issues/32>)
  * specify RUNTIME DESTINATION for libraries (#33 <https://github.com/ros-controls/realtime_tools/issues/33>)
    needed for exporting DLLs on Windows
  * Made RealtimeBuffer's copy-constructor const
  * Contributors: Bence Magyar, Gennaro Raiola, James Xu, Mathias Lüdtke, Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 11 Feb 2019 00:00:00 -0000

ros-one-realtime-tools (1.12.0-0jammy) jammy; urgency=high

  * Add RealtimePublisherSharedPtr<T>
  * boost::shared_ptr -> std::shared_ptr
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 19 May 2018 00:00:00 -0000

ros-one-realtime-tools (1.11.0-0jammy) jammy; urgency=high

  * Updated RT goal handle to handle cancel requests (#22 <https://github.com/ros-controls/realtime_tools/issues/22>)
  * switch to industrial_ci (#20 <https://github.com/ros-controls/realtime_tools/issues/20>)
  * Contributors: Mathias Lüdtke, Nick Lamprianidis

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 06 Nov 2017 00:00:00 -0000

ros-one-realtime-tools (1.10.0-0jammy) jammy; urgency=high

  * Added constructor in RTB for objects without default constructor
  * Add feedback sending capability to RealtimeServerGoalHandle.
  * Contributors: Bence Magyar, Aris Synodinos, Miguel Prada, graiola

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 28 Jun 2017 00:00:00 -0000

ros-one-realtime-tools (1.9.1-0jammy) jammy; urgency=high

  * RealtimeBox: Fix member doc
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 30 Apr 2015 00:00:00 -0000

ros-one-realtime-tools (1.9.0-0jammy) jammy; urgency=high

  * Remove rosbuild artifacts.
  * Cleaned up CMake and removed unnecessary dependencies
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 12 May 2014 00:00:00 -0000

ros-one-realtime-tools (1.8.3-0jammy) jammy; urgency=high

  * Fix linking
    The library needs to be linked against roscpp and Boost thread.
    GCC won't complain about missing symbols for a shared library,
    but other linkers (like clang's) will not accept it by default.
  * Added Travis support
  * Renamed manifest.xml so it doesn't brek rosdep
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman, Paul Mathieu

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 05 Feb 2014 00:00:00 -0000

ros-one-realtime-tools (1.8.2-0jammy) jammy; urgency=high

  * Append newline.
  * Merge pull request #4 <https://github.com/ros-controls/realtime_tools/issues/4> from pal-robotics/hydro-devel
    Add realtime action server goal handle.
  * Add realtime action server goal handle.
    - Factored out from PR2's implementation of the JointTrajectoryActionController.
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Austin Hendrix

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 29 Aug 2013 00:00:00 -0000

ros-one-realtime-tools (1.8.1-0jammy) jammy; urgency=high

  * Merge remote-tracking branch 'origin/master' into hydro-devel
  * Merge pull request #2 <https://github.com/ros-controls/realtime_tools/issues/2> from davetcoleman/master
    Made member vars mutable in realtime buffer to allow const read
  * initialize realtime_data_ and non_realtime_data_ before dereferencing and assigning to them in copy constructor
  * Added comments
  * Added readFromNonRT() function, overloaded assignment and copy constructor, and made mutex mutable.
  * Fix typos.
  * Fix build order.
  * Contributors: Austin Hendrix, Dave Coleman

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 29 Jul 2013 00:00:00 -0000

ros-one-realtime-tools (1.8.0-0jammy) jammy; urgency=high

  * Version 1.8.0
  * Install channelecho.py under catkin.
  * adding install targets
  * adding missing manifests
  * merging CMakeLists.txt files from rosbuild and catkin
  * adding hybrid-buildsystem makefiles
  * catkinizing, could still be cleaned up
  * initialize correctly
  * compile realtime clock into library
  * new interface with time and duration
  * support both condition and polling version to allow re-use of binaries in realtime; add realtime buffer to get data from non-RT into RT


=== debian/control ===
Source: ros-one-realtime-tools
Section: misc
Priority: optional
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-one-catkin, ros-one-roscpp
Homepage: http://ros.org/wiki/realtime_tools
Standards-Version: 3.9.2

Package: ros-one-realtime-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-one-actionlib, ros-one-roscpp
Description: Contains a set of tools that can be used from a hard realtime thread, without breaking the realtime behavior.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-realtime-tools//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-realtime-tools 1.15.1-3jammy.20260221.0009

=== debian/changelog ===
ros-one-realtime-tools (1.15.1-3jammy.20260221.0009) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 21 Feb 2026 00:09:55 +0000

## ros-one-realtime-tools 1.15.1-3noble.20260221.0036

=== debian/changelog ===
ros-one-realtime-tools (1.15.1-3noble.20260221.0036) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 21 Feb 2026 00:36:38 +0000

ros-one-realtime-tools (1.15.1-0noble) noble; urgency=high

  * Check whether thread joinable before joining
  * realtime_server_goal_handle_tests needs actionlib
  * Contributors: Maverobot, Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 06 Feb 2020 00:00:00 -0000

ros-one-realtime-tools (1.15.0-0noble) noble; urgency=high

  * Remove actionlib definitions
  * Contributors: Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 09 Aug 2019 00:00:00 -0000

ros-one-realtime-tools (1.14.0-0noble) noble; urgency=high

  * Undo action typedef changes
  * Remove boost
  * Clean up includes in realtime_tools namespace
  * Switch to gmock
  * Remove TARGET check on tests
  * Add unit test for RealtimeServerGoalHandle, RealtimePublisher, RealtimeClock, RealtimeBuffer, RealtimeBox
  * Fix race where first message won't get published
  * Clean up dependencies and package.xml
  * Contributors: Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 22 Jul 2019 00:00:00 -0000

ros-one-realtime-tools (1.13.1-0noble) noble; urgency=high

  * Fix actionlib regression
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 14 Feb 2019 00:00:00 -0000

ros-one-realtime-tools (1.13.0-0noble) noble; urgency=high

  * Update readme
  * use this_thread::sleep_for instead of usleep (#32 <https://github.com/ros-controls/realtime_tools/issues/32>)
  * specify RUNTIME DESTINATION for libraries (#33 <https://github.com/ros-controls/realtime_tools/issues/33>)
    needed for exporting DLLs on Windows
  * Made RealtimeBuffer's copy-constructor const
  * Contributors: Bence Magyar, Gennaro Raiola, James Xu, Mathias Lüdtke, Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 11 Feb 2019 00:00:00 -0000

ros-one-realtime-tools (1.12.0-0noble) noble; urgency=high

  * Add RealtimePublisherSharedPtr<T>
  * boost::shared_ptr -> std::shared_ptr
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 19 May 2018 00:00:00 -0000

ros-one-realtime-tools (1.11.0-0noble) noble; urgency=high

  * Updated RT goal handle to handle cancel requests (#22 <https://github.com/ros-controls/realtime_tools/issues/22>)
  * switch to industrial_ci (#20 <https://github.com/ros-controls/realtime_tools/issues/20>)
  * Contributors: Mathias Lüdtke, Nick Lamprianidis

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 06 Nov 2017 00:00:00 -0000

ros-one-realtime-tools (1.10.0-0noble) noble; urgency=high

  * Added constructor in RTB for objects without default constructor
  * Add feedback sending capability to RealtimeServerGoalHandle.
  * Contributors: Bence Magyar, Aris Synodinos, Miguel Prada, graiola

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 28 Jun 2017 00:00:00 -0000

ros-one-realtime-tools (1.9.1-0noble) noble; urgency=high

  * RealtimeBox: Fix member doc
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 30 Apr 2015 00:00:00 -0000

ros-one-realtime-tools (1.9.0-0noble) noble; urgency=high

  * Remove rosbuild artifacts.
  * Cleaned up CMake and removed unnecessary dependencies
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 12 May 2014 00:00:00 -0000

ros-one-realtime-tools (1.8.3-0noble) noble; urgency=high

  * Fix linking
    The library needs to be linked against roscpp and Boost thread.
    GCC won't complain about missing symbols for a shared library,
    but other linkers (like clang's) will not accept it by default.
  * Added Travis support
  * Renamed manifest.xml so it doesn't brek rosdep
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman, Paul Mathieu

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 05 Feb 2014 00:00:00 -0000

ros-one-realtime-tools (1.8.2-0noble) noble; urgency=high

  * Append newline.
  * Merge pull request #4 <https://github.com/ros-controls/realtime_tools/issues/4> from pal-robotics/hydro-devel
    Add realtime action server goal handle.
  * Add realtime action server goal handle.
    - Factored out from PR2's implementation of the JointTrajectoryActionController.
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Austin Hendrix

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 29 Aug 2013 00:00:00 -0000

ros-one-realtime-tools (1.8.1-0noble) noble; urgency=high

  * Merge remote-tracking branch 'origin/master' into hydro-devel
  * Merge pull request #2 <https://github.com/ros-controls/realtime_tools/issues/2> from davetcoleman/master
    Made member vars mutable in realtime buffer to allow const read
  * initialize realtime_data_ and non_realtime_data_ before dereferencing and assigning to them in copy constructor
  * Added comments
  * Added readFromNonRT() function, overloaded assignment and copy constructor, and made mutex mutable.
  * Fix typos.
  * Fix build order.
  * Contributors: Austin Hendrix, Dave Coleman

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 29 Jul 2013 00:00:00 -0000

ros-one-realtime-tools (1.8.0-0noble) noble; urgency=high

  * Version 1.8.0
  * Install channelecho.py under catkin.
  * adding install targets
  * adding missing manifests
  * merging CMakeLists.txt files from rosbuild and catkin
  * adding hybrid-buildsystem makefiles
  * catkinizing, could still be cleaned up
  * initialize correctly
  * compile realtime clock into library
  * new interface with time and duration
  * support both condition and polling version to allow re-use of binaries in realtime; add realtime buffer to get data from non-RT into RT
